Editor = {};

Editor.show = function(quote) {
   if(quote) {
        var quotemessage = $('div[data-postid="' + quote + '"]').text();
        quotemessage = base64_decode(quotemessage);
        quotemessage = $('<div>' + quotemessage + '</div>').text();
        var quoteuser     = $('.content_item .'+quote+' .header .username').text();
        $('#editor_form .text').trigger('focusin');
        $('#editor_form .text').val('[QUOTE='+quoteuser+';'+quote+']'+quotemessage+'[/QUOTE]'+'\n\n');      
    } else {
        resetInputHints($('#editor_form'));
    }
    FB.Canvas.getPageInfo(function(info) {
        var elem = $('#editor_form').prev();
        var docViewTop = info.scrollTop;
        var docViewBottom = docViewTop + info.clientHeight;

        var elemTop = elem.offset().top;
        var elemBottom = elemTop + elem.height();

        if(!((elemBottom >= docViewTop) && (elemTop <= docViewBottom))) {
            FB.Canvas.scrollTo(0, elem.offset().top - 5);
            setTimeout(Editor.showAnimation, 700);
        } else {
            Editor.showAnimation();
        }
    });
}
Editor.showAnimation = function() {
    $('#editor_form.Forums').slideDown(500, function() {    
        fix_canvas();
    });
    $('#editor_form .text').focus();
    $('#editor_form .text').putCursorAtEnd();
    FB.Canvas.scrollTo(0, $('#editor_form').offset().top - 5);
    //$('html,body').animate({scrollTop : $('#editor_form').offset().top}, {duration: 300, queue: false});
    
};
Editor.submit = function() {
    var message = $('#editor_form .text').val();
    var title = $('#editor_form input[name="title"]').val();
    var prefix = $('#prefixes').val();
    var error = Editor.validate(title, message);
    if(!error) {
        $("#editor_form .loading").animate({opacity: 1.0}, 200);
        $.ajax({
            type: 'POST',
            url: 'editor_send.php',
            dataType: "html",
            data: { 
                contenttype: $('#editor_form input[name="contenttype"]').val(),
                category: $('#editor_form input[name="category"]').val(),
                id: $('#editor_form input[name="id"]').val(),
                wall: $('#editor_chk_publish_facebook').is(':checked'),
                message: message,
                title: title,
		prefixid: prefix,
                signed_request: window.signed_request
            },
            error: function(xhr, textStatus, errorThrown) {
                $("#editor_form .loading").stop(true, true).animate({opacity: 0.0}, {duration: 100, queue: false});
                Editor.displayError('Unable to complete your request at this time: try again in a few minutes! ' + errorThrown);
            },
            success: function(response) {
                $("#editor_form .loading").stop(true, true).animate({opacity: 0.0}, {duration: 100, queue: false});
                if(response.length > 0) {
                    var jres = $.parseJSON($.trim(response));
                    if(jres.redirect) {
                        top.location.href = window.app_root + jres.redirect;
                    } else {                        
                        var errors = jres;
                        if(typeof errors[0] != 'undefined' && errors[0][0] == 'tooshort') {
                            Editor.minMessageLength = errors[0][1];
                            Editor.displayError(Editor.validations["messagelength"]["message"]());
                        } else if(typeof errors[0] != 'undefined' && errors[0][0] == 'postfloodcheck') {
                            Editor.canPostAt = ((new Date()).getTime()) + (errors[0][2] * 1000);
                            Editor.displayError("You are unable to post again for " + errors[0][2] + " seconds.");
                        } else {
                            if(typeof errors.response.errormessage != 'undefined') {
                                if($.isArray(errors.response.errormessage)) {
                                    errormessage = errors.response.errormessage[0];
                                } else {
                                    errormessage = errors.response.errormessage;
                                }
                            }
                            if(typeof errormessage != 'undefined') {
                                if(errormessage == 'nopermission_loggedin') {
                                    Editor.displayError('You are not allowed to do this at this time.');
                                } else if(errormessage == 'redirect_duplicatepost') {
                                    Editor.displayError('You are trying to post the same thing twice!');
                                } else if(errormessage == 'nopermission_loggedout') {
                                    Editor.displayError('You must log in first!');
                                } else {
                                    Editor.displayError('An unknown error occurred! (' + errormessage + ')');
                                }
                            } else {
                                Editor.displayError('An unknown error occurred!');
                            }
                        }
                    }
                } else {
                    Editor.displayError('An unknown error occurred!');
                }
            }
        });
    } else {
        Editor.displayError(error);
    }
};
Editor.displayError = function(error) {
    $('#editor_form .error').text(error);
    $('#editor_form .error').slideDown(300, function() {
        fix_canvas();
    });
    var val_func = function() {
        var error = Editor.validate($(this).val());
        if(!error) {
            $(this).unbind('keyup');
            $('#editor_form .error').slideUp(250, function() {
                fix_canvas();
            });
        } else {
            Editor.displayError(error);
        }
    };
    $('#editor_form .text').unbind('keyup').bind('keyup', val_func);
    $('#editor_form input').unbind('keyup').bind('keyup', val_func);
}
Editor.validate = function(title, message) {
    for(key in Editor.validations) {
        var validation = Editor.validations[key];
        if(!validation["test"](title, message)) {
            return validation["message"]();
        }
    }
};

Editor.minMessageLength = 2;
Editor.canPostAt = 0;

Editor.validations = {
    titledefault: {
        test: function(title, message) {
            if(typeof title != 'undefined' && title == $('#editor_form input[name="title"]').attr("data-hint")) {
                return false;
            }
            return true;
        },
        message: function() {
            return 'Please choose a title.';
        }
    },
    messagedefault: {
        test: function(title, message) {
            if(typeof message != 'undefined' && message == $('#editor_form textarea.text').attr("data-hint")) {
                return false;
            }
            return true;
        },
        message: function() {
            return 'Please enter a message.';
        }
    },
    messagelength: { 
        test: function(title, message) {
            if(typeof message != 'undefined' && message.length < Editor.minMessageLength) {
                return false;
            }
            return true;
        },
        message: function() {
            return 'Your message must be ' + Editor.minMessageLength + ' characters or more.';
        }
    },
    postfloodcheck: { 
        test: function(title, message) {
            if((Editor.canPostAt - ((new Date()).getTime())) > 0) {
                return false;
            }
            return true;
        },
        message: function() {
            return 'You are unable to post again for ' + Math.round(((Editor.canPostAt - ((new Date()).getTime())) / 1000)) + ' seconds.';
        }
    }    
};
Editor.cancel = function() {
    $('#editor_form.Forums').slideUp(400, function() {
        fix_canvas();
    }); 
    resetInputHints($('#editor_form'));
    $('#editor_form .error').hide();
};

function base64_decode (data) {
    // Decodes string using MIME base64 algorithm
    //
    // version: 1107.2516
    // discuss at: http://phpjs.org/functions/base64_decode
    // +   original by: Tyler Akins (http://rumkin.com)
    // +   improved by: Thunder.m
    // -    depends on: utf8_decode
    // *     example 1: base64_decode('S2V2aW4gdmFuIFpvbm5ldmVsZA==');
    // *     returns 1: 'Kevin van Zonneveld'
    // mozilla has this native
    // - but breaks in 2.0.0.12!
    //if (typeof this.window['btoa'] == 'function') {
    //    return btoa(data);
    //}
    var b64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
    var o1, o2, o3, h1, h2, h3, h4, bits, i = 0,
        ac = 0,
        dec = "",
        tmp_arr = [];

    if (!data) {
        return data;
    }

    data += '';

    do { // unpack four hexets into three octets using index points in b64
        h1 = b64.indexOf(data.charAt(i++));
        h2 = b64.indexOf(data.charAt(i++));
        h3 = b64.indexOf(data.charAt(i++));
        h4 = b64.indexOf(data.charAt(i++));

        bits = h1 << 18 | h2 << 12 | h3 << 6 | h4;

        o1 = bits >> 16 & 0xff;
        o2 = bits >> 8 & 0xff;
        o3 = bits & 0xff;

        if (h3 == 64) {
            tmp_arr[ac++] = String.fromCharCode(o1);
        } else if (h4 == 64) {
            tmp_arr[ac++] = String.fromCharCode(o1, o2);
        } else {
            tmp_arr[ac++] = String.fromCharCode(o1, o2, o3);
        }
    } while (i < data.length);

    dec = tmp_arr.join('');
    dec = this.utf8_decode(dec);

    return dec;
}

function utf8_decode (str_data) {
    // Converts a UTF-8 encoded string to ISO-8859-1
    //
    // version: 1107.2516
    // discuss at: http://phpjs.org/functions/utf8_decode
    // +   original by: Webtoolkit.info (http://www.webtoolkit.info/)
    // +      input by: Aman Gupta
    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // *     example 1: utf8_decode('Kevin van Zonneveld');
    // *     returns 1: 'Kevin van Zonneveld'
    var tmp_arr = [],
        i = 0,
        ac = 0,
        c1 = 0,
        c2 = 0,
        c3 = 0;

    str_data += '';

    while (i < str_data.length) {
        c1 = str_data.charCodeAt(i);
        if (c1 < 128) {
            tmp_arr[ac++] = String.fromCharCode(c1);
            i++;
        } else if (c1 > 191 && c1 < 224) {
            c2 = str_data.charCodeAt(i + 1);
            tmp_arr[ac++] = String.fromCharCode(((c1 & 31) << 6) | (c2 & 63));
            i += 2;
        } else {
            c2 = str_data.charCodeAt(i + 1);
            c3 = str_data.charCodeAt(i + 2);
            tmp_arr[ac++] = String.fromCharCode(((c1 & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
            i += 3;
        }
    }

    return tmp_arr.join('');
}

(function($)
{
    jQuery.fn.putCursorAtEnd = function()
    {
        return this.each(function()
        {
            $(this).focus()

            // If this function exists...
            if (this.setSelectionRange)
            {
                // ... then use it
                // (Doesn't work in IE)

                // Double the length because Opera is inconsistent about whether a carriage return is one character or two. Sigh.
                var len = $(this).val().length * 2;
                this.setSelectionRange(len, len);
            }
            else
            {
                // ... otherwise replace the contents with itself
                // (Doesn't work in Google Chrome)
                $(this).val($(this).val());
            }

            // Scroll to the bottom, in case we're in a tall textarea
            // (Necessary for Firefox and Google Chrome)
            this.scrollTop = 999999;
        });
    };
})(jQuery);


